#--
# This code is automatically generated, do not modify the content !!!
#++
# UESArtifactStateTemplate is a service that provides operations related to artifact state templates.
# 
# <tt><b>since</b></tt> UES8-07
class Ues::Core::Workflow::UESArtifactStateTemplate
  private_class_method :new

  BE_ARTIFACT_STATE_TEMPLATE_CODE = Java::cz.ues.core.workflow.UESArtifactStateTemplate::BE_ARTIFACT_STATE_TEMPLATE_CODE #:nodoc:

  # URI of UESArtifactStateTemplate business entity.
  BETYPE_ARTIFACT_STATE_TEMPLATE = Java::cz.ues.core.workflow.UESArtifactStateTemplate::BETYPE_ARTIFACT_STATE_TEMPLATE


# Creates a new artifact state template on the specified meta artifact. At least, its future name and type have to be specified
# in this command.
# 
# <tt><b>param</b></tt> metaArtifactUri UESURI of the meta artifact the new artifact state template is to be created on.
# 
# <tt><b>param</b></tt> artifactStateTemplate Object containing attributes of the new artifact state template.
# 
# <tt><b>return</b></tt> UESURI of the new artifact state template.
# 
# <tt><b>throws</b></tt> UESArtifactStateTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.create(metaArtifactUri, artifactStateTemplate = nil)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    artifactStateTemplate = Ues::Core::Workflow::UESArtifactStateTemplateCreate.new(artifactStateTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESArtifactStateTemplate.java_class)
    _r = _s.create(metaArtifactUri, artifactStateTemplate)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Returns attributes of the specified artifact state template.
# 
# <tt><b>param</b></tt> artifactStateTemplateUri UESURI of the artifact state template whose attributes are to be returned.
# 
# <tt><b>return</b></tt> Object with attributes of the artifact state template.
# 
# <tt><b>throws</b></tt> UESArtifactStateTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.getAttributes(artifactStateTemplateUri)
    artifactStateTemplateUri = Ues::Core::Commons::Uri::UESURI.new(artifactStateTemplateUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESArtifactStateTemplate.java_class)
    _r = _s.getAttributes(artifactStateTemplateUri)
    if (_r != nil) then _r = Ues::Core::Workflow::UESArtifactStateTemplateAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESArtifactStateTemplate
    alias attributes getAttributes
  end

# Sets attributes of an artifact state template. This command cannot modify the type and activity template.
# 
# <tt><b>param</b></tt> artifactStateTemplateUri UESURI of the artifact state template whose attributes are to be modified.
# 
# <tt><b>param</b></tt> artifactStateTemplate Object containing new attributes of the artifact state template.
# 
# <tt><b>return</b></tt> UESURI of the modified artifact state template.
# 
# <tt><b>throws</b></tt> UESArtifactStateTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.setAttributes(artifactStateTemplateUri, artifactStateTemplate = nil)
    artifactStateTemplateUri = Ues::Core::Commons::Uri::UESURI.new(artifactStateTemplateUri).to_java
    artifactStateTemplate = Ues::Core::Workflow::UESArtifactStateTemplateSetAttributes.new(artifactStateTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESArtifactStateTemplate.java_class)
    _r = _s.setAttributes(artifactStateTemplateUri, artifactStateTemplate)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESArtifactStateTemplate
    alias set_attributes setAttributes
  end

# Deletes the specified artifact state template from the system. It cannot be deleted in case there is an action
# that sets a state based on this template. Also, a system state and any state set as entry state cannot be deleted.
# 
# <tt><b>param</b></tt> artifactStateTemplateUri UESURI of the artifact state template which is to be deleted.
# 
# <tt><b>throws</b></tt> UESArtifactStateTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.delete(artifactStateTemplateUri)
    artifactStateTemplateUri = Ues::Core::Commons::Uri::UESURI.new(artifactStateTemplateUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESArtifactStateTemplate.java_class)
    _r = _s.delete(artifactStateTemplateUri)
    
    return _r
  end

# Returns a list of artifact state templates on the specified meta artifact. The command does not return all artifact
# state templates, only a sublist. The list of returned artifact state templates can be filtered by the name, code, type,
# entryState, order and activityTemplateExists. The list is sorted by the attribute order (and by name in case orders
# are equal) of an artifact state template by default, or it can be sorted arbitrarily by any of artifact state template
# attributes usable for filtering or by combinations of such attributes. See the UES query documentation for more
# information.
# 
# <tt><b>param</b></tt> metaArtifactUri UESURI of the meta artifact whose artifact state templates are to be listed.
# 
# <tt><b>param</b></tt> criteria Object containing attributes of the artifact state templates that are to be listed.
# 
# <tt><b>return</b></tt> List of Objects representing artifact state templates (the same objects as in the command getAttributes).
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">
# UESQuery Documentation.</a>
# 
# <tt><b>throws</b></tt> UESArtifactStateTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.getArtifactStateTemplateList(metaArtifactUri, criteria = nil)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    criteria = Ues::Core::Workflow::UESArtifactStateTemplateGetArtifactStateTemplateList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESArtifactStateTemplate.java_class)
    _r = _s.getArtifactStateTemplateList(metaArtifactUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESArtifactStateTemplate
    alias artifact_state_template_list getArtifactStateTemplateList
  end
end
