#--
# This code is automatically generated, do not modify the content !!!
#++
# Component for reading BE Registry data and performing operation
# with BE Types and their associations.
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES6-06
# 
# <tt><b>deprecated</b></tt> Since UES6-11 replaced by cz.ues.platform.sysc.entitytype.UESEntityType
class Ues::Platform::Sysc::Beregistry::UESBERegistry
  private_class_method :new

  # Prefix used for construction of Business Entity Type UESURI.
  BETYPE_URI_PREFIX = Java::cz.ues.platform.sysc.beregistry.UESBERegistry::BETYPE_URI_PREFIX

  # Code of Object Business Entity.
# 
# <tt><b>deprecated</b></tt> Common parent object is not used anymore in Entity Type Registry and has no direct replacement.
  BEOBJECT_CODE = Java::cz.ues.platform.sysc.beregistry.UESBERegistry::BEOBJECT_CODE

  # UESURI of Object Business Entity type.
# 
# <tt><b>deprecated</b></tt> Common parent object is not used anymore in Entity Type Registry and has no direct replacement.
  BETYPE_OBJECT = Java::cz.ues.platform.sysc.beregistry.UESBERegistry::BETYPE_OBJECT


# Returns UESURI of BE Type for given object.
# 
# <tt><b>param</b></tt> object UESURI of object for which to get BE Type
# 
# <tt><b>return</b></tt> UESURI of BE Type
# 
# <tt><b>throws</b></tt> UESBERegistryRTException In case obtaining of BE Type UESURI fails
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES6-10
  def self.getBETypeURI(object)
    warn "[DEPRECATED: Ues::Platform::Sysc::Beregistry::UESBERegistry.getBETypeURI] Since UES6-11 replaced by cz.ues.platform.sysc.entitytype.UESEntityType"
    object = Ues::Platform::Commons::Uri::UESURI.new(object).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.beregistry.UESBERegistry.java_class)
    _r = _s.getBETypeURI(object)
    if (_r != nil) then _r = Ues::Platform::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Platform::Sysc::Beregistry::UESBERegistry
    alias betype_uri getBETypeURI
  end

# Reads BE Type attributes according to given UESURI. If there is no BE Type
# with given UESURI, null is returned.
# 
# <tt><b>param</b></tt> beType UESURI of BE Type to be loaded
# 
# <tt><b>return</b></tt> Loaded BE Type or null if no such BE Type exists
# 
# <tt><b>throws</b></tt> UESBERegistryRTException In case reading of BE Type fails
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES6-06
  def self.getBETypeAttributes(beType)
    warn "[DEPRECATED: Ues::Platform::Sysc::Beregistry::UESBERegistry.getBETypeAttributes] Since UES6-11 replaced by cz.ues.platform.sysc.entitytype.UESEntityType"
    beType = Ues::Platform::Commons::Uri::UESURI.new(beType).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.beregistry.UESBERegistry.java_class)
    _r = _s.getBETypeAttributes(beType)
    if (_r != nil) then _r = Ues::Platform::Sysc::Beregistry::UESBEType.new(_r) end
    return _r
  end
  class << Ues::Platform::Sysc::Beregistry::UESBERegistry
    alias betype_attributes getBETypeAttributes
  end

# Checks if BE Type is assignable from other BE Type. If either
# of BE Types does not exist, false is returned.
# 
# <tt><b>param</b></tt> mainBEType UESURI of main BE Type (parent)
# 
# <tt><b>param</b></tt> testedBEType UESURI of tested BE Type (child)
# 
# <tt><b>return</b></tt> True if tested BE Type is assignable from main BE Type, false if not
# 
# <tt><b>throws</b></tt> UESBERegistryRTException In case check fails.
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES6-06
  def self.isAssignableFrom(mainBEType, testedBEType = nil)
    warn "[DEPRECATED: Ues::Platform::Sysc::Beregistry::UESBERegistry.isAssignableFrom] Since UES6-11 replaced by cz.ues.platform.sysc.entitytype.UESEntityType"
    mainBEType = Ues::Platform::Commons::Uri::UESURI.new(mainBEType).to_java
    testedBEType = Ues::Platform::Commons::Uri::UESURI.new(testedBEType).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.beregistry.UESBERegistry.java_class)
    _r = _s.isAssignableFrom(mainBEType, testedBEType)
    
    return _r
  end
  class << Ues::Platform::Sysc::Beregistry::UESBERegistry
    alias is_assignable_from isAssignableFrom
  end

# Checks if some object is instance of given BE Type. If given object or
# BE Type does not exist, false is returned.
# 
# <tt><b>param</b></tt> testedObject UESURI of object to be tested
# 
# <tt><b>param</b></tt> testedBEType UESURI of expected BE Type
# 
# <tt><b>return</b></tt> True if tested object is instance of given BE Type, false if not
# 
# <tt><b>throws</b></tt> UESBERegistryRTException In case check fails.
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES6-10
  def self.isInstanceOf(testedObject, testedBEType = nil)
    warn "[DEPRECATED: Ues::Platform::Sysc::Beregistry::UESBERegistry.isInstanceOf] Since UES6-11 replaced by cz.ues.platform.sysc.entitytype.UESEntityType"
    testedObject = Ues::Platform::Commons::Uri::UESURI.new(testedObject).to_java
    testedBEType = Ues::Platform::Commons::Uri::UESURI.new(testedBEType).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.beregistry.UESBERegistry.java_class)
    _r = _s.isInstanceOf(testedObject, testedBEType)
    
    return _r
  end
  class << Ues::Platform::Sysc::Beregistry::UESBERegistry
    alias is_instance_of isInstanceOf
  end
end
