#--
# This code is automatically generated, do not modify the content !!!
#++
# Component for managing BE Registry data.
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES6-06
# 
# <tt><b>deprecated</b></tt> Since UES6-11 replaced by cz.ues.platform.sysc.entitytype.UESEntityTypeRegistry
class Ues::Platform::Sysc::Beregistry::UESBERegistryManager
  private_class_method :new


# Creates new BE Type. Required attribute is BE Type code.
# 
# <tt><b>param</b></tt> sysTer UESURI of system territory where to create BE Type
# 
# <tt><b>param</b></tt> beType DTO of created BE Type
# 
# <tt><b>return</b></tt> Normalized UESURI of created BE Type
# 
# <tt><b>throws</b></tt> UESBERegistryManagerRTException in case BE Type cannot be created or creation fails
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES6-06
  def self.createBEType(sysTer, beType = nil)
    warn "[DEPRECATED: Ues::Platform::Sysc::Beregistry::UESBERegistryManager.createBEType] Since UES6-11 replaced by cz.ues.platform.sysc.entitytype.UESEntityTypeRegistry"
    sysTer = Ues::Platform::Commons::Uri::UESURI.new(sysTer).to_java
    beType = Ues::Platform::Sysc::Beregistry::UESBEType.new(beType).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.beregistry.UESBERegistryManager.java_class)
    _r = _s.createBEType(sysTer, beType)
    if (_r != nil) then _r = Ues::Platform::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Platform::Sysc::Beregistry::UESBERegistryManager
    alias create_betype createBEType
  end

# Deletes BE Type. BE Type must be leaf and must not be associated
# with other BE Types in order to be able to remove it. If given BE
# Type does not exist, method does nothing.
# 
# <tt><b>param</b></tt> sysTer UESURI of system territory where to create BE Type
# 
# <tt><b>param</b></tt> beType UESURI of BE Type to be deleted
# 
# <tt><b>throws</b></tt> UESBERegistryManagerRTException in case BE Type cannot be deleted or deletion of BE Type fails
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES6-06
  def self.deleteBEType(sysTer, beType = nil)
    warn "[DEPRECATED: Ues::Platform::Sysc::Beregistry::UESBERegistryManager.deleteBEType] Since UES6-11 replaced by cz.ues.platform.sysc.entitytype.UESEntityTypeRegistry"
    sysTer = Ues::Platform::Commons::Uri::UESURI.new(sysTer).to_java
    beType = Ues::Platform::Commons::Uri::UESURI.new(beType).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.beregistry.UESBERegistryManager.java_class)
    _r = _s.deleteBEType(sysTer, beType)
    
    return _r
  end
  class << Ues::Platform::Sysc::Beregistry::UESBERegistryManager
    alias delete_betype deleteBEType
  end

# Updates existing BE Type. Null value attributes are unchanged.
# 
# <tt><b>param</b></tt> sysTer UESURI of system territory where to create BE Type
# 
# <tt><b>param</b></tt> beType UESURI of updated BE Type
# 
# <tt><b>param</b></tt> beTypeAttributes Attributes to be set on existing BE Type
# 
# <tt><b>throws</b></tt> UESBERegistryManagerRTException in case update of BE Type fails
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES6-06
  def self.setBETypeAttributes(sysTer, beType, beTypeAttributes)
    warn "[DEPRECATED: Ues::Platform::Sysc::Beregistry::UESBERegistryManager.setBETypeAttributes] Since UES6-11 replaced by cz.ues.platform.sysc.entitytype.UESEntityTypeRegistry"
    sysTer = Ues::Platform::Commons::Uri::UESURI.new(sysTer).to_java
    beType = Ues::Platform::Commons::Uri::UESURI.new(beType).to_java
    beTypeAttributes = Ues::Platform::Sysc::Beregistry::UESBEType.new(beTypeAttributes).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.beregistry.UESBERegistryManager.java_class)
    _r = _s.setBETypeAttributes(sysTer, beType, beTypeAttributes)
    
    return _r
  end
  class << Ues::Platform::Sysc::Beregistry::UESBERegistryManager
    alias set_betype_attributes setBETypeAttributes
  end
end
